#!/usr/bin/ruby -w
# See the LICENSE file for copyright and distribution information

require "mkmf"

$LIBPATH.push(Config::CONFIG['libdir'])

def crash(str)
  print(" extconf failure: %s\n", str)
  exit 1
end

#dir_config('lua50')

unless have_library('m', 'atan')
  crash('need libm')
end

unless have_library("z", "inflate")
  crash("need zlib")
else
  $defs.push('-DHAVE_ZLIB_H')
end

unless have_library("lua50", "lua_open")
  crash(<<EOL)
need liblua50.

        Install the library or try one of the following options to extconf.rb:

        --with-lua50-dir=/path/to/liblua50
        --with-lua50-lib=/path/to/liblua50/lib
        --with-lua50-include=/path/to/liblua50/include
EOL
end

$LDFLAGS << ' ' + `lua-config --libs`.chomp

$CFLAGS << ' ' + `lua-config --include`.chomp
$CFLAGS = '-g -Wall ' + $CFLAGS


create_header()
create_makefile("language/lua")
